#pragma once

#include "openglwindow.h"

#include "camera.h"
#include "world.h"


// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

// Message handler for the Instructions dialog
INT_PTR CALLBACK Instructions(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

// Message handler for editing a coordinate.
INT_PTR CALLBACK EditCoordinate(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);



/*

The functionality of the basic OpenGL window class is extended here.
All window events handled here.

World is also extended here, which gives access to its protected methods and variables.

*/

class BezierWindow : public OpenGLWindow, public World
{
	Camera camera;

	GLObject* selected;	// Could be the light.

public:

	BezierWindow();

	~BezierWindow();

	void Destroy();

	void Create();

	void ResetCamera();

	//

	void Render();

	Vector3 cursorTo3D(int x, int y, Vector3 p);

	//

	virtual void CloseEvent(); // We want the application to end when we are closed.
	virtual void MouseDownEvent(DWORD key, int x, int y);
	virtual void KeyDownEvent(BYTE key);
	virtual void MouseMoveEvent(DWORD key, int x, int y);

	//

	virtual BOOL handleMessage(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam, LRESULT *returnCode);
};