#pragma once

#include "base.h"

/*

This is the base class for our main window. It handles the basic message loop and transforms the
corresponding messages into events handled by inheriting classes.

*/

class MainWindow
{
	HWND	m_hWnd;
	HWND	m_Client;

	HMENU	m_hMenu;

public:

	MainWindow();

	static LRESULT WINAPI	messageProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

	virtual BOOL			handleMessage(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam, LRESULT *returnCode);

	BOOL					create(MainWindow *exWindow, char *title);
	BOOL					create(MainWindow *exWindow, char *title, HICON icon, HICON smallIcon);

	BOOL					create(MainWindow *exWindow, char *title, DWORD windowStyle,
								int x, int y, int width, int height, HMENU hMenu,
								HICON icon, HICON smallIcon, HBRUSH hBrush);

	VOID					show(BOOL maximized);

	VOID					destroy();

	BOOL					flushMessage(bool* freeTime);

	HWND					handle();
	HDC						deviceHandle();
	HMENU					menu();

	VOID					setOverlapped(BOOL overlapped);

	BOOL					say(char *what);
	BOOL					say(char *what, BOOL error);

	BOOL					create(MainWindow *exWindow, char *title, BOOL maximized);
	BOOL					create(MainWindow *exWindow, char *title, LPCTSTR pMenu, HICON icon, HICON smallIcon, BOOL maximized, HBRUSH hBrush);
	BOOL					create(MainWindow *exWindow, char *title, LPCTSTR pMenu, HICON icon, HICON smallIcon, HBRUSH hBrush);

	RECT					clientRect();

	int						width();
	int						height();

	//

	virtual void			CloseEvent();
	virtual void			SizeEvent(int width, int height);
	virtual void			PaintEvent(HDC paintDC);
	virtual void			MouseDownEvent(DWORD key, int x, int y);
	virtual void			MouseMoveEvent(DWORD key, int x, int y);
	virtual void			KeyDownEvent(BYTE key);
};