#pragma once

#include "base.h"

#include "globject.h"

#define DISPLAY_LIST_ID 1

class Terrain : public GLObject
{
	int			m_Size;
	int			m_IndexCount;

	Vector3*	m_pVertices;
	Vector3*	m_pNormals;
	int*		m_pIndices;

	float*		m_pTexCoordsX;
	float*		m_pTexCoordsY;

	GLuint		m_Texture;

public:

	Terrain();

	~Terrain();

	virtual void Destroy();

	void DestroyTexture();

	bool LoadTexture(string Path);

	bool Load(string Path, string TexturePath);	// From Red Channel.

	void BuildDisplayList();

	virtual void Render();
};