#pragma once

#include <math.h>

class Vector3
{
public:

	union
	{
		struct
		{
			float m_X;
			float m_Y;
			float m_Z;
		};

		float m_V[3];
	};

public:

	Vector3();

	Vector3(float X, float Y, float Z);

	Vector3& operator = (float Scalar);
	Vector3 operator + (Vector3& Vec);
	Vector3& operator += (Vector3& Vec);
	Vector3 operator - (Vector3& Vec);
	Vector3& operator -= (Vector3& Vec);

	Vector3 ElemMult (Vector3& Vec);
	Vector3 operator * (Vector3& Vec);
	Vector3 operator * (float Scalar);
	Vector3 operator / (float Scalar);
	Vector3& operator *= (float Scalar);
	Vector3& operator /= (float Scalar);

	float Length();

	float LengthSquared();

	Vector3& Normalize();

	Vector3 Normalized();

	float Dot(Vector3& Vec);

	Vector3 operator ^ (float Scalar);

	bool operator < (Vector3& Vec);

	bool operator > (Vector3& Vec);

	//

	friend Vector3 operator * (float Scalar, Vector3& Vec);
};